"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectUtils = exports.StringUtils = void 0;
class StringUtils {}
exports.StringUtils = StringUtils;
StringUtils.capitalizeFirst = str => str[0].toUpperCase() + str.slice(1);
class ObjectUtils {
	static filterObjectByKey(object, predicate) {
		return Object.keys(object)
			.filter(predicate)
			.reduce((res, key) => ((res[key] = object[key]), res), {});
	}
	static groupBy(arr, key) {
		let grouped = [];
		for (let elem of arr) {
			let index = grouped.findIndex(
				g => JSON.stringify(g.key) === JSON.stringify(elem[key])
			);
			if (index == -1) {
				index = grouped.length;
				grouped.push({ key: elem[key], values: [] });
			}
			grouped[index].values.push(elem);
		}
		return grouped;
	}
}
exports.ObjectUtils = ObjectUtils;
