import { UpdateHandlerFn } from "../../UpdateHandler";
import { BaseButton } from "./Button";
import { BaseKeyboardBuilder } from "./KeyboardBuilder";
export declare type MatchMode = "text" | "payload";
export interface IMenuComponent<TButton extends BaseButton> {
	order: number | [row: number, column: number];
	btn: TButton;
	matchMode?: MatchMode;
}
export declare class Menu<TEvent, TButton extends BaseButton> {
	private readonly matchMode;
	private readonly keyboardBuilder;
	private btnHandlers;
	static Handler: UpdateHandlerFn<any>;
	constructor(
		matchMode: MatchMode,
		keyboardBuilder: BaseKeyboardBuilder<TButton>
	);
	build(): Pick<
		import("../../types/params").IMessageSendParams,
		"reply_markup"
	>;
	bind(opts: IMenuComponent<TButton>, handler: UpdateHandlerFn<TEvent>): this;
	private wrapHandler;
}
