"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
class Menu {
	constructor(matchMode, keyboardBuilder) {
		this.matchMode = matchMode;
		this.keyboardBuilder = keyboardBuilder;
		this.btnHandlers = [];
	}
	build() {
		return this.keyboardBuilder.build();
	}
	bind(opts, handler) {
		var _a;
		let matchMode =
			(_a = opts.matchMode) !== null && _a !== void 0
				? _a
				: this.matchMode;
		let btnHandler = this.wrapHandler(matchMode, opts.btn, handler);
		let order =
			typeof opts.order == "number" ? [opts.order, 0] : opts.order;
		this.btnHandlers.push({
			handler: btnHandler,
			btn: opts.btn,
			order,
		});
		return this;
	}
	wrapHandler(matchMode, btn, handler) {
		return (evt, next) => {
			if (
				(matchMode == "payload" && btn["payload"] == evt["data"]) ||
				(matchMode == "text" && btn.text == evt["text"])
			)
				return handler(evt, next);
			else next();
		};
	}
}
exports.Menu = Menu;
